/*
 ***************************************************************************
 * Ralink Tech Inc.
 * 4F, No. 2 Technology 5th Rd.
 * Science-based Industrial Park
 * Hsin-chu, Taiwan, R.O.C.
 *
 * (c) Copyright, Ralink Technology, Inc.
 *
 * All rights reserved. Ralink's source code is an unpublished work and the
 * use of a copyright notice does not imply otherwise. This source code
 * contains confidential trade secret material of Ralink Tech. Any attemp
 * or participation in deciphering, decoding, reverse engineering or in any
 * way altering the source code is stricitly prohibited, unless the prior
 * written consent of Ralink Technology, Inc. is obtained.
 ***************************************************************************
 */

#ifndef __RALINK_GPIO_H__
#define __RALINK_GPIO_H__

#include "../../include/asm-mips/rt2880/rt_mmap.h"
#include "gconfig.h"

/* time period */
#ifdef TIME_PERIOD1
unsigned int time_period1 = TIME_PERIOD1;
#else
unsigned int time_period1 = 2;
#endif
#ifdef TIME_PERIOD2
unsigned int time_period2 = TIME_PERIOD2;
#else
unsigned int time_period2 = 5;
#endif
#ifdef TIME_PERIOD3
unsigned int time_period3 = TIME_PERIOD3;
#else
unsigned int time_period3 = 10;
#endif

/*
 * ioctl commands
 */
#define	RALINK_GPIO_SET_DIR		0x01
#define RALINK_GPIO_SET_DIR_IN		0x11
#define RALINK_GPIO_SET_DIR_OUT		0x12
#define	RALINK_GPIO_READ		0x02
#define	RALINK_GPIO_WRITE		0x03
#define	RALINK_GPIO_SET			0x21
#define	RALINK_GPIO_CLEAR		0x31
#define	RALINK_GPIO_READ_BIT		0x04
#define	RALINK_GPIO_WRITE_BIT		0x05
#define	RALINK_GPIO_READ_BYTE		0x06
#define	RALINK_GPIO_WRITE_BYTE		0x07
#define	RALINK_GPIO_READ_INT		RALINK_GPIO_READ
#define	RALINK_GPIO_WRITE_INT		RALINK_GPIO_WRITE
#define	RALINK_GPIO_SET_INT		RALINK_GPIO_SET
#define	RALINK_GPIO_CLEAR_INT		RALINK_GPIO_CLEAR
#define RALINK_GPIO_ENABLE_INTP		0x08
#define RALINK_GPIO_DISABLE_INTP	0x09
#define RALINK_GPIO_REG_IRQ		0x0A
#define RALINK_GPIO_RESET		0x0B
#define RALINK_GPIO_PWR_LED		0x0C
#define	RALINK_GPIO_READ_DIR		0x0D
#define	RALINK_GPIO_FACTORY		0x0E
#define RALINK_GPIO_LED_SET		0x41
#define	RALINK_GPIO_RESET_RT2880	0x61
#define	RALINK_GPIO_CONTROL_RT2880	0x62
#define	RALINK_GPIO_GET_CMD_FROM_RT3052	 0x63
#define	RALINK_GPIO_GET_PID_FROM_USER	 0x64
#define	RALINK_GPIO_RT2880_WPS_START	 0x65
#define	RALINK_GPIO_RT3052_WPS_START	 0x66
#define	RALINK_GPIO_ENABLE_USB_FLAG	 0x67
#define	RALINK_GPIO_WPS_TIME	         0x68
#define	RALINK_GPIO_WPS_TIME2	         0x69

#define RT2880GPIO_ENABLE_INTP		RALINK_GPIO_ENABLE_INTP
#define RT2880GPIO_REG_IRQ              RALINK_GPIO_REG_IRQ 
#define RT2880GPIO_PWR_LED		RALINK_GPIO_PWR_LED
#define	RT2880GPIO_FACTORY		RALINK_GPIO_FACTORY

#define FLASH_MAX_RW_SIZE		0x100


/*
 * Address of RALINK_ Registers
 */
#define RALINK_SYSCTL_ADDR		RALINK_SYSCTL_BASE	// system control
#define RALINK_REG_GPIOMODE		(RALINK_SYSCTL_ADDR + 0x60)

#define RALINK_IRQ_ADDR			RALINK_INTCL_BASE
#define RALINK_REG_INTENA		(RALINK_IRQ_ADDR + 0x34)
#define RALINK_REG_INTDIS		(RALINK_IRQ_ADDR + 0x38)

#define RALINK_PRGIO_ADDR		RALINK_PIO_BASE // Programmable I/O
#define RALINK_REG_PIOINT		(RALINK_PRGIO_ADDR + 0)
#define RALINK_REG_PIOEDGE		(RALINK_PRGIO_ADDR + 0x04)
#define RALINK_REG_PIORENA		(RALINK_PRGIO_ADDR + 0x08)
#define RALINK_REG_PIOFENA		(RALINK_PRGIO_ADDR + 0x0C)
#define RALINK_REG_PIODATA		(RALINK_PRGIO_ADDR + 0x20)
#define RALINK_REG_PIODIR		(RALINK_PRGIO_ADDR + 0x24)
#define RALINK_REG_PIOSET		(RALINK_PRGIO_ADDR + 0x2C)
#define RALINK_REG_PIORESET		(RALINK_PRGIO_ADDR + 0x30)


/*
 * Values for the GPIOMODE Register
 */
#ifdef CONFIG_RALINK_RT2880
#define RALINK_GPIOMODE_I2C		0x01
#define RALINK_GPIOMODE_UARTF		0x02
#define RALINK_GPIOMODE_SPI		0x04
#define RALINK_GPIOMODE_UARTL		0x08
#define RALINK_GPIOMODE_JTAG		0x10
#define RALINK_GPIOMODE_MDIO		0x20
#define RALINK_GPIOMODE_SDRAM		0x40
#define RALINK_GPIOMODE_PCI		0x80
#elif defined (CONFIG_RALINK_RT3052) || defined (CONFIG_RALINK_RT2883)
#define RALINK_GPIOMODE_I2C		0x01
#define RALINK_GPIOMODE_SPI		0x02
#define RALINK_GPIOMODE_UARTF		0x1C
#define RALINK_GPIOMODE_UARTL		0x20
#define RALINK_GPIOMODE_JTAG		0x40
#define RALINK_GPIOMODE_MDIO		0x80
#define RALINK_GPIOMODE_SDRAM		0x100
#define RALINK_GPIOMODE_RGMII		0x200
#endif

// if you would like to enable GPIO mode for other pins, please modify this value
// !! Warning: changing this value may make other features(MDIO, PCI, etc) lose efficacy
#define RALINK_GPIOMODE_DFT	(RALINK_GPIOMODE_I2C | RALINK_GPIOMODE_SPI | RALINK_GPIOMODE_UARTF | 	RALINK_GPIOMODE_MDIO)

/*
 * bit is the unit of length
 */
#define RALINK_GPIO_NUMBER		24
#define RALINK_GPIO_DATA_MASK		0x00FFFFFF
#define RALINK_GPIO_DATA_LEN		24
#define RALINK_GPIO_DIR_IN		0
#define RALINK_GPIO_DIR_OUT		1
#define RALINK_GPIO_DIR_ALLIN		0
#define RALINK_GPIO_DIR_ALLOUT		0x00FFFFFF
#ifdef iNIC_2880
#define RALINK_GPIO_CONTROL_RT2880_MASK	     0x00FFFFFF
#define RALINK_GPIO_CONTROL_RT2880_MASK_0    0x00000010
#else
#define RALINK_GPIO_CONTROL_RT2880_MASK	     0x00FFFFBF
#define RALINK_GPIO_CONTROL_RT2880_MASK_0    0x00000040
#endif
/*
 * structure used at regsitration
 */
typedef struct {
	unsigned int irq;		//request irq pin number
	pid_t pid;			//process id to notify
} ralink_gpio_reg_info;

#define RALINK_GPIO_LED_LOW_ACT		1
#define RALINK_GPIO_LED_INFINITY	4000
typedef struct {
	int gpio;			//gpio number (-1, 0 ~ 24)
	unsigned int on;		//interval of led on
	unsigned int off;		//interval of led off
	unsigned int blinks;		//number of blinking cycles
	unsigned int rests;		//number of break cycles
	unsigned int times;		//blinking times
} ralink_gpio_led_info;


#define RALINK_GPIO_0			0x00000001
#define RALINK_GPIO_1			0x00000002
#define RALINK_GPIO_2			0x00000004
#define RALINK_GPIO_3			0x00000008
#define RALINK_GPIO_4			0x00000010
#define RALINK_GPIO_5			0x00000020
#define RALINK_GPIO_6			0x00000040
#define RALINK_GPIO_7			0x00000080
#define RALINK_GPIO_8			0x00000100
#define RALINK_GPIO_9			0x00000200
#define RALINK_GPIO_10			0x00000400
#define RALINK_GPIO_11			0x00000800
#define RALINK_GPIO_12			0x00001000
#define RALINK_GPIO_13			0x00002000
#define RALINK_GPIO_14			0x00004000
#define RALINK_GPIO_15			0x00008000
#define RALINK_GPIO_16			0x00010000
#define RALINK_GPIO_17			0x00020000
#define RALINK_GPIO_18			0x00040000
#define RALINK_GPIO_19			0x00080000
#define RALINK_GPIO_20			0x00100000
#define RALINK_GPIO_21			0x00200000
#define RALINK_GPIO_22			0x00400000
#define RALINK_GPIO_23			0x00800000
#define RALINK_GPIO(x)			(1 << x)

/* marklin 20080811 : GPIO config */
#define WPS_GPIO_PIN                0
#define RT3052_RESET_RT2880_PIN     4
#define RALINK_GPIO_RESET_PIN       7
#define PWR_LED_GPIO_PIN            8
#define WPS_LED_GPIO_PIN           14
#define RESET2DEF_GPIO_PIN	   10
#ifdef iNIC_2880
#define GPIO_CONTROL_2880_PIN1      5
#define GPIO_CONTROL_2880_PIN2      6
#define GPIO_CONTROL_2880_PIN3      4
#define GPIO_CONTROL_2880_PIN4      10
#else
#define GPIO_CONTROL_2880_PIN1      1
#define GPIO_CONTROL_2880_PIN2      2
#define GPIO_CONTROL_2880_PIN3      6
#define GPIO_CONTROL_2880_PIN4      9
#endif
#define WDI_GPIO_PIN               11
#endif
